/*
   7 April 2019
   Have an A*Micro with an LM335Z temp sensor and an nRF24 module mounted. This module will
   broadcast temp data to receiver node. 
*/
#include <avr/sleep.h> //
#include <avr/wdt.h> //

//initializes/defines the output pin of the LM335 temperature sensor
int outputPin = A1;
const int tempPower = 4;

//int watchdog_counter = 0;

//ISR(WDT_vect) {  watchdog_counter++;  }


void setup()
{
  Serial.begin(9600);
  while (!Serial) ;  // for 32u4 boards?
  delay(100);

  pinMode(tempPower, OUTPUT);
  digitalWrite(tempPower, LOW);

/*  watchdog_counter = 0;
  set_sleep_mode(SLEEP_MODE_PWR_DOWN); 
  sleep_enable();
  setup_watchdog(6); //Wake up after some time  */
}

void loop()
{
  /*  sleep_mode();

  USBCON = 0;

  if (watchdog_counter >= 4) {

    USBDevice.attach();   */

    digitalWrite(tempPower, HIGH);
    delay(10);

    int rawvoltage = analogRead(outputPin);
    float millivolts = (rawvoltage / 1024.0) * 5000;
    float kelvin = (millivolts / 10);
    Serial.print(kelvin);
    Serial.println(" degrees Kelvin");

    float celsius = kelvin - 273.15;
    Serial.print(celsius);
    Serial.println(" degrees Celsius");

    float fahrenheit = ((celsius * 9) / 5 + 32);
    Serial.print(fahrenheit);
    Serial.println(" degrees Fahrenheit");

    digitalWrite(tempPower, LOW);

    analogReference(INTERNAL);
    analogRead(A0);
    delay(10);
    float value = 0;
    for (int i = 0; i < 10; i++) {
      value = value + analogRead(A0);
      delay(10);
    }
    value = value / 10;
    analogReference(DEFAULT);
    analogRead(A0);
    delay(10);
    Serial.print(value);
    float mV = map(value, 0, 1023, 0, 2560 / 0.0909091);
    Serial.print(", millivolts = ");
    Serial.println(mV);
    Serial.println("**********************");
  //}
  delay(4000);
}

//Sets the watchdog timer to wake us up, but not reset
//0=16ms, 1=32ms, 2=64ms, 3=128ms, 4=250ms, 5=500ms
//6=1sec, 7=2sec, 8=4sec, 9=8sec
void setup_watchdog(int timerPrescaler) {

  if (timerPrescaler > 9 ) timerPrescaler = 9; //only nine steps

  byte bb = timerPrescaler & 7;
  if (timerPrescaler > 7) bb |= (1 << 5); //Set the special 5th bit if necessary

  //This order of commands is important and cannot be combined
  MCUSR &= ~(1 << WDRF); //Clear the watch dog reset
  WDTCSR |= (1 << WDCE) | (1 << WDE); //Set WD_change enable, set WD enable
  WDTCSR = bb; //Set new watchdog timeout value
  WDTCSR |= _BV(WDIE); //Set the interrupt enable, this will keep unit from resetting after each int
}
